X-Git-Url: https://git.xinqibao.xyz/dmenu.git/blobdiff_plain/4042a11e5174633e9beeeec120937856e1d0f74f..a662fc6e0abeacb64b5b37cedccaeee782f9454e:/dmenu_path?ds=sidebyside

diff --git a/dmenu_path b/dmenu_path
index e590a5c..59fe64d 100755
--- a/dmenu_path
+++ b/dmenu_path
@@ -1,30 +1,9 @@
 #!/bin/sh
 CACHE=$HOME/.dmenu_cache
-UPTODATE=1
 IFS=:
 
-if test ! -f $CACHE 
-then
-	unset UPTODATE
+if ! test -f "$CACHE" || find $PATH -type d -newer "$CACHE" | grep -q .; then
+	find -L $PATH -type f \( -perm -1 -o -perm -10 -o -perm -100 \) | sed 's/.*\///' | sort -u > "$CACHE"
 fi
 
-if test $UPTODATE
-then
-	for dir in $PATH
-	do
-		test $dir -nt $CACHE && unset UPTODATE
-	done
-fi
-
-if test ! $UPTODATE
-then
-	for dir in $PATH
-	do
-		for file in "$dir"/*
-		do
-			test -x "$file" && echo "${file##*/}"
-		done
-	done | sort | uniq > $CACHE
-fi
-
-cat $CACHE
+cat "$CACHE"